Index: branches/stable/DNSDB.pm
===================================================================
--- branches/stable/DNSDB.pm	(revision 544)
+++ branches/stable/DNSDB.pm	(revision 545)
@@ -3,5 +3,5 @@
 ##
 # $Id$
-# Copyright 2008-2011 Kris Deugau <kdeugau@deepnet.cx>
+# Copyright 2008-2012 Kris Deugau <kdeugau@deepnet.cx>
 # 
 #    This program is free software: you can redistribute it and/or modify
@@ -30,49 +30,61 @@
 use NetAddr::IP qw(:lower);
 use POSIX;
+use Fcntl qw(:flock);
+
 use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);
 
-$VERSION	= "1.0.5";	##VERSION##
+$VERSION	= 1.1;	##VERSION##
 @ISA		= qw(Exporter);
 @EXPORT_OK	= qw(
-	&initGlobals
+	&initGlobals &login &initActionLog
 	&initPermissions &getPermissions &changePermissions &comparePermissions
 	&changeGroup
 	&loadConfig &connectDB &finish
-	&addDomain &delDomain &domainName &revName &domainID &addRDNS
-	&getZoneCount &getZoneList
+	&addDomain &delZone &domainName &revName &domainID &revID &addRDNS
+	&getZoneCount &getZoneList &getZoneLocation
 	&addGroup &delGroup &getChildren &groupName
+	&getGroupCount &getGroupList
 	&addUser &updateUser &delUser &userFullName &userStatus &getUserData
-	&getSOA	&getRecLine &getDomRecs &getRecCount
+	&getUserCount &getUserList &getUserDropdown
+	&addLoc &updateLoc &delLoc &getLoc
+	&getLocCount &getLocList &getLocDropdown
+	&getSOA	&updateSOA &getRecLine &getDomRecs &getRecCount
 	&addRec &updateRec &delRec
+	&getLogCount &getLogEntries
 	&getTypelist
 	&parentID
 	&isParent
-	&domStatus &importAXFR
+	&zoneStatus &importAXFR
 	&export
 	&mailNotify
 	%typemap %reverse_typemap %config
-	%permissions @permtypes $permlist
+	%permissions @permtypes $permlist %permchains
 	);
 
 @EXPORT		= (); # Export nothing by default.
 %EXPORT_TAGS	= ( ALL => [qw(
-		&initGlobals
+		&initGlobals &login &initActionLog
 		&initPermissions &getPermissions &changePermissions &comparePermissions
 		&changeGroup
 		&loadConfig &connectDB &finish
-		&addDomain &delDomain &domainName &revName &domainID &addRDNS
-		&getZoneCount &getZoneList
+		&addDomain &delZone &domainName &revName &domainID &revID &addRDNS
+		&getZoneCount &getZoneList &getZoneLocation
 		&addGroup &delGroup &getChildren &groupName
+		&getGroupCount &getGroupList
 		&addUser &updateUser &delUser &userFullName &userStatus &getUserData
-		&getSOA &getRecLine &getDomRecs &getRecCount
+		&getUserCount &getUserList &getUserDropdown
+		&addLoc &updateLoc &delLoc &getLoc
+		&getLocCount &getLocList &getLocDropdown
+		&getSOA &updateSOA &getRecLine &getDomRecs &getRecCount
 		&addRec &updateRec &delRec
+		&getLogCount &getLogEntries
 		&getTypelist
 		&parentID
 		&isParent
-		&domStatus &importAXFR
+		&zoneStatus &importAXFR
 		&export
 		&mailNotify
 		%typemap %reverse_typemap %config
-		%permissions @permtypes $permlist
+		%permissions @permtypes $permlist %permchains
 		)]
 	);
@@ -80,4 +92,5 @@
 our $group = 1;
 our $errstr = '';
+our $resultstr = '';
 
 # Halfway sane defaults for SOA, TTL, etc.
@@ -97,12 +110,23 @@
 
 # Arguably defined wholly in the db, but little reason to change without supporting code changes
+# group_view, user_view permissions? separate rDNS permission(s)?
 our @permtypes = qw (
 	group_edit	group_create	group_delete
 	user_edit	user_create	user_delete
 	domain_edit	domain_create	domain_delete
-	record_edit	record_create	record_delete
+	record_edit	record_create	record_delete	record_locchg
+	location_edit	location_create	location_delete	location_view
 	self_edit	admin
 );
 our $permlist = join(',',@permtypes);
+
+# Some permissions more or less require certain others.
+our %permchains = (
+	user_edit	=> 'self_edit',
+	location_edit	=> 'location_view',
+	location_create	=> 'location_view',
+	location_delete	=> 'location_view',
+	record_locchg	=> 'location_view',
+);
 
 # DNS record type map and reverse map.
@@ -135,4 +159,5 @@
 #		cssdir	=> 'templates/',
 		sessiondir	=> 'session/',
+		exportcache	=> 'cache/',
 
 		# Session params
